// GrtSelDlg.cpp : implementation file
//

#include "stdafx.h"
#include "CMA.h"
#include "GrtSelDlg.h"

#include "MyWin32Port.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CString comPort, gblSUnit;
extern long gblCurWL;
extern int gblNGrtSelted;

/////////////////////////////////////////////////////////////////////////////
// CGrtSelDlg dialog


CGrtSelDlg::CGrtSelDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGrtSelDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGrtSelDlg)
	m_iGrtSelCancel = 0;
	m_iGrtSelStatus = 0;
	m_lGrtSelTOut = 40000;
	m_iGrtSelNew = 1;
	//}}AFX_DATA_INIT
}


void CGrtSelDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGrtSelDlg)
	DDX_Control(pDX, IDC_OK, m_cOK);
	DDX_Text(pDX, IDC_GRTSELCANCEL, m_iGrtSelCancel);
	DDX_Text(pDX, IDC_GRTSELSTATUS, m_iGrtSelStatus);
	DDX_Text(pDX, IDC_GRTSELTOUT, m_lGrtSelTOut);
	DDX_Text(pDX, IDC_GRTSELNEW, m_iGrtSelNew);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CGrtSelDlg, CDialog)
	//{{AFX_MSG_MAP(CGrtSelDlg)
	ON_BN_CLICKED(IDC_OK, OnOk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGrtSelDlg message handlers

BOOL CGrtSelDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here

	m_eReading = READ_BYTES;
	m_iGrtSelNew=gblNGrtSelted;
	//update variables
	UpdateData(FALSE);

	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CGrtSelDlg::OnOk() 
{
	// TODO: Add your control notification handler code here

	BYTE IDcmd, StatusB, CancelB;
	BYTE LoB;
	long timeout;
	// Update the variable
	UpdateData(TRUE);
	timeout=m_lGrtSelTOut;		//2s
	LoB=m_iGrtSelNew;

	IDcmd=26;
	openCOM(comPort);

	WriteByte( IDcmd );
	WriteByte( LoB );

	StatusB=ReadByte(timeout);
	CancelB=ReadByte(timeout);
	m_iGrtSelStatus=StatusB;
	m_iGrtSelCancel=CancelB;
	//update dialog
	UpdateData(FALSE);

	if (StatusB <= 127)
	{
		gblNGrtSelted = m_iGrtSelNew;
		gblCurWL=0;
	}
	else
	{
		if ( (StatusB & 64)==0)
			MessageBox("An error has occurred !",
				"Status >= 128",
				MB_ICONSTOP);
		else
		gblNGrtSelted = m_iGrtSelNew;
		gblCurWL=0;
	}


	closeCOM();
	
}

/****************************************************************************
 * This function's return value is an INTEGER.  A value of zero indicates   *
 * success.  Non-zero return values indicate an error has occured.          *
 ****************************************************************************/
int CGrtSelDlg::openCOM(CString comPort)
{
	int iRtn;
	iRtn=0;
	CString port_name;
	port_name = comPort;
	int baud_rate = 9600;
	int word_size = 8;
	int stop_bits = 1;
	int xon_xoff = 0;
	int rts_cts = 0;
	int dtr_dsr = 0;

	CString parity;
	parity = "None";
	m_pPort = new MyWin32Port( this->m_hWnd,
								   (const char *) port_name, 
			                       baud_rate, 
								   parity[ 0 ], 
								   word_size, 
								   stop_bits,
								   UNCHANGED,
								   UNCHANGED,
								   xon_xoff,
								   rts_cts,
								   dtr_dsr );
	if ( m_pPort->ErrorStatus() == RS232_SUCCESS ) 
		iRtn=0;
	else
		iRtn=1;

	return iRtn;
}


/****************************************************************************
 * CLOSE																	*
 ****************************************************************************/
void CGrtSelDlg::closeCOM()
{
	delete m_pPort;
	m_pPort = 0;
}

/****************************************************************************
 * WriteByte(int iByte)														*
 ****************************************************************************/
void CGrtSelDlg::WriteByte(int iByte)
{
	m_pPort->Write( iByte, 1 );
}

/****************************************************************************
 * ReadByte(int iByte)														*
 ****************************************************************************/
int CGrtSelDlg::ReadByte(long lTime)
{
	return(m_pPort->Read( lTime ));
}
